Select an ARM-hosted cross build with a separate makefile target instead of
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # The version number of the submission, e.g. 1007.
53 LLVM_SUBMIT_VERSION="${11}"
54
55 # The subversion number of the submission, e.g. 03.
56 LLVM_SUBMIT_SUBVERSION="${12}"
57
58 # The current working directory is where the build will happen. It may already
59 # contain a partial result of an interrupted build, in which case this script
60 # will continue where it left off.
61 DIR=`pwd`
62
63 DARWIN_VERS=`uname -r | sed 's/\..*//'`
64 echo DARWIN_VERS = $DARWIN_VERS
65
66 DEVELOPER_DIR="${DEVELOPER_DIR-Developer}"
67 if [ "$ARM_HOSTED_BUILD" = yes ]; then
68     DT_HOME="$DEST_DIR/usr"
69     HOST_SDKROOT=$SDKROOT
70 else
71     DT_HOME="$DEST_DIR/$DEVELOPER_DIR/usr"
72 fi
73
74 DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
75
76 ################################################################################
77 # Run the build.
78
79 # Create the source tree we'll actually use to build, deleting
80 # tcl since it doesn't actually build properly in a cross environment
81 # and we don't really need it.
82 SRC_DIR=$DIR/src
83 rm -rf $SRC_DIR || exit 1
84 mkdir $SRC_DIR || exit 1
85 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
86 # We can't use the top-level Makefile as-is.  Remove the soft link:
87 rm $SRC_DIR/Makefile || exit 1
88 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
89 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
90
91 # Build the LLVM tree universal.
92 mkdir -p $DIR/obj-llvm || exit 1
93 cd $DIR/obj-llvm || exit 1
94
95 if [ "$ARM_HOSTED_BUILD" = yes ]; then
96   # The cross-tools' build process expects to find an existing cross toolchain
97   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
98   rm -rf $DIR/bin || exit 1
99   mkdir $DIR/bin || exit 1
100   for prog in ar nm ranlib strip lipo ld as ; do
101     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
102     T=`xcrun -sdk $SDKROOT -find ${prog}`
103     echo '#!/bin/sh' > $P || exit 1
104     echo 'exec '$T' "$@"' >> $P || exit 1
105     chmod a+x $P || exit 1
106   done
107   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
108   for prog in gcc g++ ; do
109     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
110     T=`xcrun -find llvm-${prog}`
111     if [ "x$T" = "x" ] ; then
112       T=`xcrun -sdk $SDKROOT -find ${prog}`
113     fi
114     echo '#!/bin/sh' > $P || exit 1
115     echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
116     chmod a+x $P || exit 1
117   done
118
119   PATH=$DIR/bin:$PATH
120 # otherwise, try to use llvm-gcc if it's available
121 elif [ $DARWIN_VERS -gt 9 ]; then
122   # If the user has set CC or CXX, respect their wishes.  If not,
123   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
124   # available, fall back to usual GCC/G++ default.
125   savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
126   XTMPCC=$(which llvm-gcc)
127   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
128   XTMPCC=$(which llvm-g++)
129   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
130   PATH=$savedPATH
131   unset XTMPCC savedPATH
132 fi
133
134 if [ "$ARM_HOSTED_BUILD" = yes ]; then
135   configure_prefix=$DT_HOME
136   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
137                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
138 else
139   configure_prefix=$DT_HOME/local
140   configure_opts="--enable-targets=arm,x86,powerpc,cbe"
141 fi
142
143 if [ \! -f Makefile.config ]; then
144   $SRC_DIR/configure --prefix=$configure_prefix $configure_opts \
145     --enable-assertions=$LLVM_ASSERTIONS \
146     --enable-optimized=$LLVM_OPTIMIZED \
147     --disable-bindings \
148     || exit 1
149 fi
150
151 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
152
153 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
154     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
155     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
156     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
157 fi
158
159 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
160     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
161 else
162     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
163 fi
164
165 GCC_VER=`cc --version 2>/dev/null | sed 1q`
166
167 if echo "$GCC_VER" | grep GCC > /dev/null; then
168     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
169     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
170     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
171 fi
172
173 JOBS_FLAG=""
174
175 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
176 # already has parallelism and we don't want to make the builders hit swap by
177 # firing off too many gccs at the same time.
178 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
179     # Figure out how many make processes to run.
180     SYSCTL=`sysctl -n hw.activecpu`
181
182     # hw.activecpu only available in 10.2.6 and later
183     if [ -z "$SYSCTL" ]; then
184         SYSCTL=`sysctl -n hw.ncpu`
185     fi
186
187     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
188     # Builders can default to 2, since even if they are single processor,
189     # nothing else is running on the machine.
190     if [ -z "$SYSCTL" ]; then
191         SYSCTL=2
192     fi
193
194     JOBS_FLAG="-j $SYSCTL"
195 fi
196
197 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
198     UNIVERSAL_SDK_PATH=$HOST_SDKROOT \
199     NO_RUNTIME_LIBS=1 \
200     DISABLE_EDIS=1 \
201     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
202     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
203     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
204     VERBOSE=1
205
206 if [ $? != 0 ] ; then
207     echo "error: LLVM 'make' failed!"
208     exit 1
209 fi 
210
211 ################################################################################
212 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
213 # $DEST_DIR, with occasional 'lipo' commands.
214
215 cd $DEST_DIR || exit 1
216
217 # Clean out DEST_DIR in case -noclean was passed to buildit.
218 rm -rf * || exit 1
219
220 cd $DIR/obj-llvm || exit 1
221
222 # Install the tree into the destination directory.
223 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
224     NO_RUNTIME_LIBS=1 \
225     DISABLE_EDIS=1 \
226     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
227     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
228     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
229
230 if ! test $? == 0 ; then
231     echo "error: LLVM 'make install' failed!"
232     exit 1
233 fi 
234
235 # Install Version.h
236 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
237 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
238     LLVM_MINOR_VERSION=0
239 fi
240 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
241 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
242 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
243
244 if [ "x$LLVM_DEBUG" != "x1" ]; then
245     # Strip local symbols from llvm libraries.
246     strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
247     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
248         strip -Sx $f
249     done
250 fi
251
252 # Copy over the tblgen utility.
253 cp `find $DIR -name tblgen` $DT_HOME/local/bin
254
255 # Remove .dir files 
256 cd $DEST_DIR$DEST_ROOT
257 rm -f bin/.dir etc/llvm/.dir lib/.dir
258
259 # Remove PPC64 fat slices.
260 cd $DEST_DIR$DEST_ROOT/bin
261 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
262     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
263         -exec lipo -extract ppc -extract i386 {} -output {} \;
264 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
265     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
266         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
267 else
268     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
269         -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
270 fi
271
272 cd $DEST_DIR$DEST_ROOT
273 if [ "$INSTALL_LIBLTO" == yes ]; then
274   mkdir -p $DT_HOME/lib
275   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
276   strip -S $DT_HOME/lib/libLTO.dylib
277 fi
278 rm -f lib/libLTO.a lib/libLTO.la
279
280 # The Hello dylib is an example of how to build a pass. No need to install it.
281 rm lib/libLLVMHello.dylib
282
283 # Compress manpages
284 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
285 gzip -f $MDIR/*
286
287 ################################################################################
288 # Create SYM_DIR with information required for debugging.
289
290 # Figure out how many make processes to run.
291 SYSCTL=`sysctl -n hw.activecpu`
292
293 # hw.activecpu only available in 10.2.6 and later
294 if [ -z "$SYSCTL" ]; then
295   SYSCTL=`sysctl -n hw.ncpu`
296 fi
297
298 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
299 # can default to 2, since even if they are single processor, nothing else is
300 # running on the machine.
301 if [ -z "$SYSCTL" ]; then
302   SYSCTL=2
303 fi
304
305 cd $SYM_DIR || exit 1
306
307 # Clean out SYM_DIR in case -noclean was passed to buildit.
308 rm -rf * || exit 1
309
310 # Generate .dSYM files
311 find $DEST_DIR -perm -0111 -type f \
312     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
313     -print | xargs -n 1 -P ${SYSCTL} dsymutil
314
315 # Save .dSYM files and .a archives
316 cd $DEST_DIR || exit 1
317 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
318     | cpio -pdml $SYM_DIR || exit 1
319
320 # Save source files.
321 mkdir $SYM_DIR/src || exit 1
322 cd $DIR || exit 1
323 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
324     | cpio -pdml $SYM_DIR/src || exit 1
325
326 ################################################################################
327 # Remove debugging information from DEST_DIR.
328
329 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
330 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
331 chgrp -h -R wheel $DEST_DIR
332 chgrp -R wheel $DEST_DIR
333
334 ################################################################################
335 # Remove tar ball from docs directory
336
337 find $DEST_DIR -name html.tar.gz -exec rm {} \;
338
339 ################################################################################
340 # symlinks so that B&I can find things
341
342 if [ "$INSTALL_LIBLTO" == yes ]; then
343   mkdir -p $DEST_DIR/usr/lib/
344   cd $DEST_DIR/usr/lib && \
345     ln -s ../../$DEVELOPER_DIR/usr/lib/libLTO.dylib ./libLTO.dylib
346 fi
347
348 ################################################################################
349 # w00t! Done!
350
351 exit 0